.586p
.model  flat, stdcall
locals
jumps

include                 c:\tasm32\include\shitheap.inc

calle                   macro   __xxx
                        call    dword ptr[ebp+__xxx]
                        endm

.data
ofn                     openfilename    <0>
dumpfile                db      512     dup(0)
importdump              db      512     dup(0)
fsize                   dd      ?
fsize1                  dd      ?
magic                   dd      ?
iatrva                  dd      ?
fhandle                 dd      ?
fhandle1                dd      ?
shandle                 dd      ?
shandle1                dd      ?
mhandle                 dd      ?
mhandle1                dd      ?

about                   db      "SVKP import fixer", 13, 10
                        db      "1st field is for dumped file to fix", 13, 10
                        db      "2nd field is for import table dump", 13, 10
                        db      "3rd field is for magic number from SVKP", 13, 10
                        db      "4th field is for import table RVA",13, 10
                        db      "tested against SVKP 1.3x and 1.4", 13, 10
                        db      13, 10
                        db      "              S verom u Boga, deroko/ARTeam", 0
atitle                  db      "SVKP Import fixer", 0
magicbuffer             db      32      dup(0)

.code
start:
                        push    0
                        callW   GetModuleHandleA
                        
                        push    0
                        push    offset dialogproc
                        push    0
                        push    999
                        push    eax
                        callW   DialogBoxParamA
                        
                        push    0
                        callW   ExitProcess
                        
dialogproc              proc    hdlg:dword, wmsg:dword, wparam:dword, lparam:dword
                        pushad
                        xor     eax, eax
                        cmp     wmsg, WM_COMMAND
                        je      __wmcommand
                        cmp     wmsg, WM_CLOSE
                        jne     __exitdialog

                        push    0
                        push    hdlg
                        callW   EndDialog
                        mov     eax, 1
                        jmp     __exitdialog
                        
__wmcommand:            cmp     wparam, 0
                        je      __opendumpedfile
                        cmp     wparam, 1
                        je      __openimportdump
                        cmp     wparam, 2
                        je      __insertloader
                        cmp     wparam, 7
                        jne     __exitdialog
                        
                        push    40h
                        pushs   <"SVKP import fixer">
                        push    offset about
                        push    hdlg
                        callW   MessageBoxA
                        mov     eax, 1
                        jmp     __exitdialog

__opendumpedfile:       push    hdlg
                        pop     ofn.ofn_hwndOwner
                        mov     ofn.ofn_lStructSize, size openfilename     
                        mov     ofn.ofn_lpstrFile, offset dumpfile            
                        mov     ofn.ofn_nMaxFile,512      
                        mov     ofn.ofn_lpstrTitle, offset atitle             
                        mov     ofn.ofn_Flags, OFN_FILEMUSTEXIST or \ 
                                             OFN_PATHMUSTEXIST or \ 
                                             OFN_LONGNAMES or     \ 
                                             OFN_EXPLORER or      \ 
                                             OFN_HIDEREADONLY 
                        push    offset ofn
                        callW   GetOpenFileNameA
                        test    eax, eax
                        jz      __selectsomefile
                        
                        push    offset dumpfile
                        push    3
                        push    hdlg
                        callW   SetDlgItemTextA
                        mov     eax, 1
                        jmp     __exitdialog
                        
__openimportdump:       push    hdlg
                        pop     ofn.ofn_hwndOwner
                        mov     ofn.ofn_lStructSize, size openfilename     
                        mov     ofn.ofn_lpstrFile, offset importdump           
                        mov     ofn.ofn_nMaxFile,512      
                        mov     ofn.ofn_lpstrTitle, offset atitle             
                        mov     ofn.ofn_Flags, OFN_FILEMUSTEXIST or \ 
                                             OFN_PATHMUSTEXIST or \ 
                                             OFN_LONGNAMES or     \ 
                                             OFN_EXPLORER or      \ 
                                             OFN_HIDEREADONLY 
                        push    offset ofn
                        callW   GetOpenFileNameA
                        test    eax, eax
                        jz      __selectsomefile 
                        
                        push    offset importdump
                        push    4
                        push    hdlg
                        callW   SetDlgItemTextA
                        mov     eax, 1
                        jmp     __exitdialog
                        
__selectsomefile:       push    30h
                        push    offset atitle
                        pushs   <"select some file">
                        push    hdlg
                        callW   MessageBoxA
                        mov     eax, 1
                        jmp     __exitdialog      

__insertloader:         push    512
                        push    offset dumpfile
                        push    3
                        push    hdlg
                        callW   GetDlgItemTextA
                        
                        push    512
                        push    offset importdump
                        push    4
                        push    hdlg
                        callW   GetDlgItemTextA
                        
                        push    32
                        push    offset magicbuffer
                        push    5
                        push    hdlg
                        callW   GetDlgItemTextA
                        test    eax, eax
                        jnz     __gethexvalue
                        
                        push    10h
                        push    0
                        pushs   <"MAGIC is missing">
                        push    hdlg
                        callW   MessageBoxA
                        mov     eax, 1
                        jmp     __exitdialog
                        
__gethexvalue:          push    offset magicbuffer
                        call    htodw
                        mov     magic, eax
                        
                        push    32
                        push    offset magicbuffer
                        push    8
                        push    hdlg
                        callW   GetDlgItemTextA
                        test    eax, eax
                        jnz     __gethexvalue2
                        
                        push    10h
                        push    0
                        pushs   <"IAT RVA is missing">
                        push    hdlg
                        callW   MessageBoxA
                        
__gethexvalue2:         push    offset magicbuffer
                        call    htodw
                        mov     iatrva, eax
                        
                        
                        mov     eax, 1 
                        
                        call    injectloader 
                        
                        push    40h
                        pushs   <"done">
                        pushs   <"run loader till jmp eax or stop at oep", 13, 10, "run importrec and recover imports">
                        push    hdlg
                        callW   MessageBoxA
                        
                                 
                        mov     eax, 1
                        
__exitdialog:           mov     [esp.Pushad_eax], eax
                        popad
                        ret
                        endp

include                 htodw.inc


injectloader:           push    0
                        push    0
                        push    OPEN_EXISTING
                        push    0
                        push    0
                        push    GENERIC_READ + GENERIC_WRITE
                        push    offset dumpfile
                        callW   CreateFileA
                        test    eax, eax
                        js      __error
                        mov     fhandle, eax 

                        push    0
                        push    0
                        push    OPEN_EXISTING
                        push    0
                        push    0
                        push    GENERIC_READ
                        push    offset importdump
                        callW   CreateFileA
                        test    eax, eax
                        js      __error
                        mov     fhandle1, eax
                        
                        push    0
                        push    fhandle
                        callW   GetFileSize
                        mov     fsize, eax
                        
                        push    0
                        push    fhandle1
                        callW   GetFileSize
                        mov     fsize1, eax
                        
                        add     eax, fsize
                        add     eax, 1000h      ;size of loader I'll change this latter
                        mov     fsize, eax
                        
                        push    0
                        push    fsize
                        push    0
                        push    PAGE_READWRITE
                        push    0
                        push    fhandle
                        callW   CreateFileMappingA
                        test    eax, eax
                        jz      __error
                        mov     shandle, eax
                        
                        push    0
                        push    0
                        push    0
                        push    PAGE_READONLY
                        push    0
                        push    fhandle1
                        callW   CreateFileMappingA
                        test    eax, eax
                        jz      __error
                        mov     shandle1, eax                        

                        push    fsize
                        push    0
                        push    0
                        push    FILE_MAP_WRITE
                        push    shandle
                        callW   MapViewOfFile
                        test    eax, eax
                        jz      __error
                        mov     mhandle, eax
                        
                        push    0
                        push    0
                        push    0
                        push    FILE_MAP_READ	
                        push    shandle1
                        callW   MapViewOfFile
                        test    eax, eax
                        jz      __error
                        mov     mhandle1, eax
                        
                        mov     ebx, mhandle
                        add     ebx, dword ptr[ebx+3ch]
                        
                        movzx   ecx, [ebx.NT_FileHeader.FH_NumberOfSections]
                        dec     ecx
                        imul    ecx, ecx, size IMAGE_SECTION_HEADER
                        
                        lea     eax, [ebx+0F8h] ;<--- ptr to last section
                        
                        mov     esi, [eax.SH_PointerToRawData]
                        add     esi, [eax.SH_SizeOfRawData]
                        add     esi, mhandle
                        
                        push    eax
                        
;prepare needed data in loader
                        mov     eax, iatrva
                        mov     patch_iat, eax
                        mov     patch_iat2, eax

                        mov     eax, fsize1
                        shr     eax, 2
                        mov     patch_iat_size, eax
                        
                        mov     eax, magic
                        mov     patch_magic, eax
                        
                        mov     eax, [ebx.NT_OptionalHeader.OH_AddressOfEntryPoint]
                        mov     patch_oep, eax
                        
                        mov     eax, [ebx.NT_OptionalHeader.OH_ImageBase]
                        mov     imagebase, eax
;all needed patched here... now copy tis shit...
                        
                        mov     edi, esi
                        mov     esi, offset loader
                        mov     ecx, loader_size
                        cld
                        rep     movsb
                        
                        mov     esi, mhandle1
                        mov     ecx, fsize1
                        rep     movsb
                        
                        pop     eax
                        mov     esi, [eax.SH_VirtualAddress]
                        add     esi, [eax.SH_VirtualSize]
                        
                        mov     [ebx.NT_OptionalHeader.OH_AddressOfEntryPoint], esi
                        
                        mov     esi, [eax.SH_PointerToRawData]
                        add     esi, [eax.SH_SizeOfRawData]
                        
                        sub     fsize, esi
                        mov     esi, fsize
                        
                        add     [eax.SH_SizeOfRawData], esi
                        add     [eax.SH_VirtualSize], esi
                        add     [ebx.NT_OptionalHeader.OH_SizeOfImage], esi
                        

                        push    fhandle
                        push    fhandle1
                        push    shandle
                        push    shandle1
                        push    mhandle
                        push    mhandle1
                        callW   UnmapViewOfFile
                        callW   UnmapViewOfFile
                        callW   CloseHandle
                        callW   CloseHandle
                        callW   CloseHandle
                        callW   CloseHandle
                        
                        
__exit:                 ret

__error:                push    10h
                        push    0
                        pushs   <"something went wrong">
                        push    0
                        callW   MessageBoxA
                        jmp     __exit

loader:
                     call   delta
delta:               call   getkernelbase
                     pop    ebp
                     sub    ebp, offset delta
                     mov    [ebp+kernel32], eax
                     gethash <LoadLibraryA>
                     push   hash
                     push   eax
                     call   getprocaddress1
                     mov    [ebp+LoadLibraryA], eax
                     gethash <GetProcAddress>
                     push  hash
                     push   [ebp+kernel32]
                     call   getprocaddress1
                     mov    [ebp+GetProcAddress], eax
                     
                     lea    esi, [ebp+imports]          ;bin dump of imports.bin (imports.inc)
                     mov    edi, 10000001h
patch_iat               = dword ptr $-4
                     add    edi, [ebp+imagebase]
                     mov    ecx, 10000001h
patch_iat_size          = dword ptr $-4
                     cld
                     rep    movsd                       ;copy iat...
                     
                     mov    esi, 10000001h                    ;iat in esi
patch_iat2              = dword ptr $-4
                     add    esi, [ebp+imagebase]
__banzzai:                     
                     cmp    [esi.ID_FirstThunk], 0
                     je     __go_to_oep
                     mov    ebx, [esi.ID_Name]
                     add    ebx, [ebp+imagebase]
                     cmp    [ebx], 'CEPS'
                     je     __next
                     push   ebx
                     calle  LoadLibraryA                ;<--- loadlib for this apiset
                     mov    [ebp+tempdll], eax          ;<--- save it
                     mov    edi, [esi.ID_FirstThunk]    ;<--- first thunk in edi
                     add    edi, [ebp+imagebase]
__next_crc:                     
                     cmp    dword ptr[edi], 0           ;<--- last????
                     je     __next
                     mov    ebx, [edi]                  ;<--- rva in ebx
                     test   ebx, 80000000h              ;<--- oridnal?
                     jnz    __ordinal
                     add    ebx, [ebp+imagebase]        ;<--- add image base
                     add    ebx, 2
                     mov    eax, [ebx] 
                     sub    eax, 10000001h              ;<--- magic to get good hash 
patch_magic             = dword ptr $-4
                     push   eax                         ;<--- hash in eax
                     push   [ebp+tempdll]               ;<--- dll base
                     call   getprocaddress              ;<--- getaddre by crc32 hash
                     jmp    __store
__ordinal:           and    ebx, 0FFFFh
                     push   ebx
                     push   [ebp+tempdll]
                     calle  GetProcAddress
__store:
                     stosd                              ;<--- save address in EDI
                     jmp    __next_crc                  ;<--- go for next          
__next:
                     add    esi, size IMAGE_IMPORT_DESCRIPTOR
                     jmp    __banzzai

__go_to_oep:
                     mov    eax, 10000001h
patch_oep            = dword ptr $-4
                     add    eax, [ebp+imagebase]
                     jmp    eax

getprocaddress1:
                        pushad                   
                        mov    ebx, dword ptr[esp+8*4+4]
                        mov    ecx, ebx
                        add    ebx, [ebx.MZ_lfanew]			
                        mov    ebx, [ebx.NT_OptionalHeader.OH_DirectoryEntries.DE_Export.DD_VirtualAddress]
                        add    ebx, ecx
                        mov    edi, [ebx.ED_AddressOfNames]
                        add    edi, ecx
                        xor    esi, esi                           ;esi counter                  				
__find_api1:            lea    edx, dword ptr[edi+esi*4]
                        mov    edx, dword ptr[edx]			
                        add    edx, ecx				
                        xor    eax, eax				
__11:                   rol    eax, 7					;hash algo  (x) by z0mbie
                        xor    al, byte ptr [edx]
                        inc    edx					
                        cmp    byte ptr [edx], 0			
                        jnz    __11					
                        cmp    eax, dword ptr[esp+8+8*4]             	       
                        je     __find_ordinal1				    
                        inc    esi					
                        cmp    esi, [ebx.ED_NumberOfNames]		
                        jb     __find_api1                    
__find_ordinal1:        mov    edx, [ebx.ED_AddressOfOrdinals]	
                        add    edx, ecx				
                        movzx  edx, word ptr [edx+esi*2]		
                        mov    eax, [ebx.ED_AddressOfFunctions]	
                        add    eax, ecx				
                        mov    eax, [eax+edx*4]			
                        add    eax, ecx
                        mov    [esp.Pushad_eax], eax
                        popad				
__end1:                 ret           8  
include                 crc32.inc  

imagebase               dd      ?
kernel32                dd      ? 
tempdll                 dd      ?   
dllname                 dd      ?                 
LoadLibraryA            dd      ?
GetProcAddress          dd      ?

loader_size             =       $-loader

imports:                                        ;imports are copied here in loader
                        end     start
                        
